<template>
  <q-card>
    <q-card-section class="" :class="{'bg-primary text-white': active}">
        <div class="text-h6">{{ props.folder.name }}</div>
        <div class="text-subtitle2">Files: {{ props.folder.file_count }}</div>
      </q-card-section>

      <q-separator />

      <q-card-actions align="right">
        <q-btn
          flat
          @click="makeActive(props.folder)"
        >Diese Modell verwenden</q-btn>
        <q-btn flat :href="props.folder.download_link">Download Folder</q-btn>
        <q-btn flat @click="confirm = true" color="warning">Delete Folder</q-btn>
      </q-card-actions>
  </q-card>

  <q-dialog v-model="confirm" persistent>
      <q-card>
        <q-card-section class="row items-center">
          <span class="q-ml-sm">Möchtest du den Ordner wirklich löschen?</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Abbrechen" color="primary" v-close-popup />
          <q-btn
            flat
            label="Löschen"
            @click="deleteFolder(props.folder)"
            color="primary"
            v-close-popup
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useApiStore } from 'stores/api-store';
import {
  IModelFolder,
} from 'src/lib/generated-axios-client/api';

interface Props {
  folder: IModelFolder,
  active: boolean,
}

const apiStore = useApiStore();
const confirm = ref(false);
const working = ref(false);

const deleteFolder = async (folder: IModelFolder) => {
  working.value = true;
  try {
    await apiStore.deleteModel(folder);
    await apiStore.updateModelFolderList();
  } finally {
    working.value = false;
  }
};

const makeActive = async (folder: IModelFolder) => {
  await apiStore.setActiveModel(folder);
};

const props = defineProps<Props>();
</script>
